commit ccd11da0599c190f5b678aed3f164579ca873c71
Author: Tzafrir Cohen <tzafrir@cohens.org.il>
Date:   Mon Sep 8 10:59:06 2008 +0000

    Locking fixes in chan_dahdi: lock chan before pvt

diff --git a/channels/chan_dahdi.c b/channels/chan_dahdi.c
index 35c4e4e..c12c112 100644
--- a/channels/chan_dahdi.c
+++ b/channels/chan_dahdi.c
@@ -9105,7 +9105,7 @@ static void *pri_dchannel(void *vpri)
 	int haveidles;
 	int activeidles;
 	int nextidle = -1;
-	struct ast_channel *c;
+	struct ast_channel *c = NULL;
 	struct timeval tv, lowest, *next;
 	struct timeval lastidle = { 0, 0 };
 	int doidling=0;
@@ -9846,6 +9846,7 @@ static void *pri_dchannel(void *vpri)
 								snprintf(calledtonstr, sizeof(calledtonstr)-1, "%d", e->ring.calledplan);
 								pbx_builtin_setvar_helper(c, "CALLEDTON", calledtonstr);
 
+								ast_mutex_lock(&c->lock);
 								ast_mutex_lock(&pri->pvts[chanpos]->lock);
 								ast_mutex_lock(&pri->lock);
 
@@ -9893,6 +9894,8 @@ static void *pri_dchannel(void *vpri)
 					if (crv)
 						ast_mutex_unlock(&crv->lock);
 					ast_mutex_unlock(&pri->pvts[chanpos]->lock);
+					if (c)
+						ast_mutex_unlock(&c->lock);
 				} else {
 					if (e->ring.flexible)
 						pri_hangup(pri->pri, e->ring.call, PRI_CAUSE_NORMAL_CIRCUIT_CONGESTION);
